import request from "request-promise-native";
import { ApiKeyResponse, DownloadsResponse, PackagesResponse, PublisherOverviewResponse, RevenueResponse, SalesPeriodsResponse, SalesResponse, UserOverviewResponse, VerifyInvoiceResponse } from "./interfaces.js";
export default class AssetStoreClient {
    private token;
    private publisherID?;
    private config?;
    constructor(token: string, publisherID?: number | undefined, config?: request.RequestPromiseOptions | undefined);
    logout(): Promise<any>;
    salesInterface(): Promise<any>;
    userOverview(): Promise<UserOverviewResponse>;
    publisherOverview(): Promise<PublisherOverviewResponse>;
    salesPeriods(publisherID?: number): Promise<SalesPeriodsResponse>;
    sales(year: number, month: number, publisherID?: number): Promise<SalesResponse>;
    downloads(year: number, month: number, publisherID?: number): Promise<DownloadsResponse>;
    verifyInvoice(invoice: string, publisherID?: number): Promise<VerifyInvoiceResponse>;
    revenue(publisherID?: number): Promise<RevenueResponse>;
    packages(): Promise<PackagesResponse>;
    apiKey(publisherID?: number): Promise<ApiKeyResponse>;
    private assetStoreRequestJSON;
    private getID;
}
//# sourceMappingURL=index.d.ts.map