"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var request_promise_native_1 = __importDefault(require("request-promise-native"));
function pad(num, size, padChar) {
    if (padChar === void 0) { padChar = "0"; }
    var s = String(num);
    while (s.length < (size || 2)) {
        s = padChar + s;
    }
    return s;
}
var AssetStoreClient = /** @class */ (function () {
    function AssetStoreClient(token, publisherID, config) {
        this.token = token;
        this.publisherID = publisherID;
        this.config = config;
    }
    AssetStoreClient.prototype.logout = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assetStoreRequestJSON("https://publisher.assetstore.unity3d.com/logout")];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AssetStoreClient.prototype.salesInterface = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assetStoreRequestJSON("https://publisher.assetstore.unity3d.com/sales.html")];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AssetStoreClient.prototype.userOverview = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assetStoreRequestJSON("https://publisher.assetstore.unity3d.com/api/user/overview.json")];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AssetStoreClient.prototype.publisherOverview = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assetStoreRequestJSON("https://publisher.assetstore.unity3d.com/api/publisher/overview.json")];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AssetStoreClient.prototype.salesPeriods = function (publisherID) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assetStoreRequestJSON("https://publisher.assetstore.unity3d.com/api/publisher-info/months/" + this.getID(publisherID) + ".json")];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AssetStoreClient.prototype.sales = function (year, month, publisherID) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assetStoreRequestJSON("https://publisher.assetstore.unity3d.com/api/publisher-info/sales/" + this.getID(publisherID) + "/" + pad(year * 100 + month, 6) + ".json")];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AssetStoreClient.prototype.downloads = function (year, month, publisherID) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assetStoreRequestJSON("https://publisher.assetstore.unity3d.com/api/publisher-info/downloads/" + this.getID(publisherID) + "/" + pad(year * 100 + month, 6) + ".json")];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AssetStoreClient.prototype.verifyInvoice = function (invoice, publisherID) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assetStoreRequestJSON("https://publisher.assetstore.unity3d.com/api/publisher-info/verify-invoice/" + this.getID(publisherID) + "/" + invoice + ".json")];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AssetStoreClient.prototype.revenue = function (publisherID) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assetStoreRequestJSON("https://publisher.assetstore.unity3d.com/api/publisher-info/revenue/" + this.getID(publisherID) + ".json")];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AssetStoreClient.prototype.packages = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assetStoreRequestJSON("https://publisher.assetstore.unity3d.com/api/management/packages.json")];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AssetStoreClient.prototype.apiKey = function (publisherID) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assetStoreRequestJSON("https://publisher.assetstore.unity3d.com/api/publisher-info/api-key/" + this.getID(publisherID) + ".json")];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AssetStoreClient.prototype.assetStoreRequestJSON = function (url) {
        return __awaiter(this, void 0, void 0, function () {
            var jar, req, response, obj;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        jar = request_promise_native_1.default.jar(false);
                        req = __assign({ method: "GET", headers: { "Content-Type": "application/json" }, jar: jar }, (this.config || {}));
                        jar.setCookie("kharma_session=" + this.token, url);
                        return [4 /*yield*/, request_promise_native_1.default(url, req)];
                    case 1:
                        response = _a.sent();
                        obj = JSON.parse(response);
                        return [2 /*return*/, obj];
                }
            });
        });
    };
    AssetStoreClient.prototype.getID = function (publisherID) {
        if (publisherID || this.publisherID) {
            return publisherID || this.publisherID;
        }
        throw new Error("No publisher ID specified");
    };
    return AssetStoreClient;
}());
exports.default = AssetStoreClient;
